<template>

   <component :is="component" class="chill-entity entity-address">

      <component :is="component" class="address" :class="multiline">

         <div v-if="isConfidential">
            <confidential :positionBtnFar="true">
               <template v-slot:confidential-content>
                  <div v-if="isMultiline === true">
                     <p v-for="(l, i) in address.lines" :key="`line-${i}`">
                        {{ l }}
                     </p>
                     <p v-if="showButtonDetails"><address-details-button :address_id="address.address_id" :address_ref_status="address.refStatus"></address-details-button></p>
                  </div>
                  <div v-else>
                     <p v-if="'' !== address.text"
                        class="street">
                        {{ address.text }}
                     </p>
                     <p v-if="null !== address.postcode"
                        class="postcode">
                        {{ address.postcode.code }} {{ address.postcode.name }}
                     </p>
                     <p v-if="null !== address.country"
                        class="country">
                        {{ address.country.name.fr }}
                     </p>
                  </div>
               </template>
            </confidential>
         </div>

         <div v-if="!isConfidential">
            <div v-if="isMultiline === true">
               <p v-for="(l, i) in address.lines" :key="`line-${i}`">
                  {{ l }}
               </p>
               <p v-if="showButtonDetails"><address-details-button :address_id="address.address_id" :address_ref_status="address.refStatus"></address-details-button></p>
            </div>
            <div v-else>
               <p v-if="address.text"
                  class="street">
                  {{ address.text }} <template v-if="showButtonDetails"><address-details-button :address_id="address.address_id" :address_ref_status="address.refStatus"></address-details-button></template>
               </p>
            </div>
         </div>

      </component>

      <div v-if="useDatePane === true" class="address-more">
         <div v-if="address.validFrom">
            <span class="validFrom">
               <b>{{ $t('validFrom') }}</b>: {{ $d(address.validFrom.date) }}
            </span>
         </div>
         <div v-if="address.validTo">
            <span class="validTo">
               <b>{{ $t('validTo') }}</b>: {{ $d(address.validTo.date) }}
            </span>
         </div>
      </div>

   </component>
</template>

<script>

import Confidential from 'ChillMainAssets/vuejs/_components/Confidential.vue';
import AddressDetailsButton from "ChillMainAssets/vuejs/_components/AddressDetails/AddressDetailsButton.vue";

export default {
   name: 'AddressRenderBox',
   components: {
      Confidential,
      AddressDetailsButton,
   },
   props: {
      address: {
         type: Object
      },
      isMultiline: {
         default: true,
         type: Boolean
      },
      useDatePane: {
         default: false,
         type: Boolean
      },
      showButtonDetails: {
        default: true,
        type: Boolean
      }
   },
   computed: {
      component() {
         return this.isMultiline === true ? "div" : "span";
      },
      multiline() {
         return this.isMultiline === true ? "multiline" : "";
      },
      isConfidential() {
         return this.address.confidential;
      }
   }
};
</script>

<style lang="scss" scoped>
p {
   &:after {
      content: " ";
      margin-right: 0.3em;
   }
}
</style>
